-- ============================================================
--   Table: USR_CISAUTO_FORNE
-- ============================================================
create table USR_CISAUTO_FORNE
  (
    CNPJEMPRESA     VARCHAR2(20) NOT NULL,
    CDCENTCUST      VARCHAR2(12) NOT NULL,
    NRAUTOFORNE     VARCHAR2(10) NOT NULL,
    CDFORNECED      VARCHAR2(6),
    CDARMAZEM       VARCHAR2(2) NOT NULL,
    DTAUTOFORN      DATE,
    VRTOTALAF       FLOAT(126),
    CDCONDFORN      VARCHAR2(3) NOT NULL,
    CDLOJA          VARCHAR2(2) NOT NULL,
    CDITEM          VARCHAR2(4) NOT NULL,
    SGUNIDADE       VARCHAR2(2) NOT NULL,
    CDPRODUTO       VARCHAR2(20) NOT NULL,
    CDMARCA         VARCHAR2(5),
    VRQUANTIDADE    FLOAT(126) NOT NULL,
    VRUNITARIO      FLOAT(126) NOT NULL,
    VRTOTAL         FLOAT(126) NOT NULL,
    VRPERDESAF      FLOAT(126),
    VRDESCITMAF     FLOAT(126),
    TXOBSITMAF      VARCHAR2(30),
    DTPROGENTAF     DATE,
    IDINTERFACE     VARCHAR2(1) NOT NULL,
    LOG_ERRO        VARCHAR2(4000),
    DTGRAVACAO      DATE,
    HRGRAVACAO      VARCHAR2(5),
    DTIMPORTACAO    DATE,
    HRIMPORTACAO    VARCHAR2(5)
  )
/

ALTER TABLE USR_CISAUTO_FORNE ADD constraint PK_USR_CISAUTO_FORNE primary key (CDCENTCUST, NRAUTOFORNE, CDITEM, CDPRODUTO, CDMARCA, DTPROGENTAF)
/

-- ============================================================
--   Table: USR_CISBAIXA_AUTOFORNE
-- ============================================================
CREATE TABLE USR_CISBAIXA_AUTOFORNE
  (
    CDCENTCUST        VARCHAR2(12) NOT NULL,
    NRAUTOFORNE       VARCHAR2(6) NOT NULL,
    CDITEM            VARCHAR2(4) NOT NULL,
    CDPRODUTO         VARCHAR2(20) NOT NULL,
    IDINTERFACE       VARCHAR2(1) NOT NULL,
    LOG_ERRO          VARCHAR2(250),
    DTGRAVACAO        DATE NOT NULL,
    HRGRAVACAO        VARCHAR2(5) NOT NULL,
    DTIMPORTACAO      DATE,
    HRIMPORTACAO      VARCHAR2(5)
  )
/

ALTER TABLE USR_CISBAIXA_AUTOFORNE ADD constraint PK_USR_CISBAIXA_AUTOFORNE primary key (CDCENTCUST, NRAUTOFORNE, CDITEM, CDPRODUTO)
/
CREATE INDEX USR_CISBAIXA_AUTOFORNE_01 ON USR_CISBAIXA_AUTOFORNE(DTIMPORTACAO)
/

-- ============================================================
--   Table: USR_CISDEVO_COMPRA
-- ============================================================
CREATE TABLE USR_CISDEVO_COMPRA
  (
    CDCENTCUST        VARCHAR2(12) NOT NULL,
    NRAUTOFORNE       VARCHAR2(6) NOT NULL,
    CDFORNECED        VARCHAR2(8),
    NRNOTAFISCAL      VARCHAR2(9) NOT NULL,
    DTSAIDA           DATE NOT NULL,
    DTEMISSAO         DATE,
    CDPRODUTO         VARCHAR2(20) NOT NULL,
    VRQUANTIDADE      FLOAT(126) NOT NULL,
    VRQUANTAT         FLOAT(126) NOT NULL,
    VRUNITARIO        FLOAT(126) NOT NULL,
    CDSERIE           VARCHAR2(5),
    IDINTERFACE       VARCHAR2(1) NOT NULL,
    LOG_ERRO          VARCHAR2(250),
    DTGRAVACAO        DATE NOT NULL,
    HRGRAVACAO        VARCHAR2(5) NOT NULL,
    DTIMPORTACAO      DATE,
    HRIMPORTACAO      VARCHAR2(5),
    NRLANCESTQ        VARCHAR2(10)
  )
/
ALTER TABLE USR_CISDEVO_COMPRA MODIFY CDFORNECED NOT NULL
/
ALTER TABLE USR_CISDEVO_COMPRA ADD constraint PK_USR_CISDEVO_COMPRA primary key (CDCENTCUST, NRNOTAFISCAL, CDFORNECED, NRAUTOFORNE, CDPRODUTO)
/
CREATE INDEX USR_CISDEVO_COMPRA_01 ON USR_CISDEVO_COMPRA(DTIMPORTACAO)
/


-- ============================================================
--   Table: USR_CISNF_TRANS
-- ============================================================
CREATE TABLE USR_CISNF_TRANS
  (
    NRPEDVENDA        VARCHAR2(6) NOT NULL,
    IDSTATUSNFE       VARCHAR2(1) NOT NULL,
    NRACESSONFE       VARCHAR2(44),
    DTEMISSAO         DATE NOT NULL,
    NRNOTAFISCAL      VARCHAR2(20),
    CDSERIE           VARCHAR2(5),
    IDINTERFACE       VARCHAR2(1) NOT NULL,
    LOG_ERRO          VARCHAR2(250),
    DTGRAVACAO        DATE NOT NULL,
    HRGRAVACAO        VARCHAR2(5) NOT NULL,
    DTIMPORTACAO      DATE,
    HRIMPORTACAO      VARCHAR2(5)
  )
/

-- ============================================================
--   Table: USR_CISPEDIDO_VENDA
-- ============================================================
CREATE TABLE USR_CISPEDIDO_VENDA
  (
    CNPJEMPRESA       VARCHAR2(20) NOT NULL, 
    IDIMPORTADO       VARCHAR2(1) NOT NULL,
    NRPEDVENDA        VARCHAR2(6) NOT NULL,
    CDCENTCUST        VARCHAR2(12) NOT NULL,
    CDCONDPAG         VARCHAR2(2) NOT NULL,
    TES               VARCHAR2(3) NOT NULL,
    CDCLIENTE         VARCHAR2(20) NOT NULL,
    CDLOJA            VARCHAR2(2) NOT NULL,
    DTSAIDA           DATE NOT NULL,
    CODARMAZEM        VARCHAR2(2) NOT NULL,
    CDPRODUTO         VARCHAR2(20) NOT NULL,
    SGUNIDADE         VARCHAR2(5) NOT NULL,
    VRQUANTIDADE      FLOAT(126) NOT NULL,
    VRUNITARIO        FLOAT(126) NOT NULL,
    VRTOTAL           FLOAT(126) NOT NULL,
    IDINTERFACE       VARCHAR2(1) NOT NULL,
    LOG_ERRO          VARCHAR2(250),
    DTGRAVACAO        DATE NOT NULL,
    HRGRAVACAO        VARCHAR2(5) NOT NULL,
    DTIMPORTACAO      DATE,
    HRIMPORTACAO      VARCHAR2(5),
    NRLANCTONF        VARCHAR2(10),
    CDFILIAL          VARCHAR2(4),
    NRSEQITPROD       VARCHAR2(4),
    NRPRODPROT        VARCHAR2(6),
    NRNOTAPROT        VARCHAR2(6)
  )
/

ALTER TABLE USR_CISPEDIDO_VENDA MODIFY CDFILIAL NOT NULL
/
ALTER TABLE USR_CISPEDIDO_VENDA MODIFY NRLANCTONF NOT NULL
/
ALTER TABLE USR_CISPEDIDO_VENDA MODIFY NRSEQITPROD NOT NULL
/
ALTER TABLE USR_CISPEDIDO_VENDA ADD constraint PK_USR_CISPEDIDO_VENDA primary key (CDFILIAL, NRLANCTONF, NRSEQITPROD)
/
CREATE INDEX USR_CISPEDIDO_VENDA_01 ON USR_CISPEDIDO_VENDA(NRNOTAPROT)
/


-- ============================================================
--   Table: USR_CISPOS_ESTOQUE
-- ============================================================
CREATE TABLE USR_CISPOS_ESTOQUE
  (
    CDPRODUTO         VARCHAR2(20) NOT NULL,
    CDARMAZEM         VARCHAR2(2) NOT NULL,
    VRQUANTIDADE      FLOAT(126),
    VRATUAL           FLOAT(126),
    IDINTERFACE       VARCHAR2(1) NOT NULL,
    LOG_ERRO          VARCHAR2(250),
    DTGRAVACAO        DATE NOT NULL,
    HRGRAVACAO        VARCHAR2(5) NOT NULL,
    DTIMPORTACAO      DATE,
    HRIMPORTACAO      VARCHAR2(5)
  )
/

-- ============================================================
--   Table: USR_CISPROT_CLIENTE
-- ============================================================
CREATE TABLE USR_CISPROT_CLIENTE
  (
    CGCCLIE        VARCHAR2(14) NOT NULL,
    CDCLIPROTHEUS  VARCHAR2(8) NOT NULL,
    NMRAZAOSOC     VARCHAR2(60) NOT NULL,
    NMFANTCLIE     VARCHAR2(20) NOT NULL,
    DSENDERECO     VARCHAR2(67),
    CDPAIS         VARCHAR2(5) NOT NULL,
    NMPAIS         VARCHAR2(30) NOT NULL,
    SGESTADO       VARCHAR2(2) NOT NULL,
    CDMUNCIPIO     VARCHAR2(7)  NOT NULL, 
    NMMUNICIPIO    VARCHAR2(30) NOT NULL,
    CDCEP          VARCHAR2(8),
    NMBAIRRO       VARCHAR2(20),
    EMAIL          VARCHAR2(100),
    CDFORMPGTO     VARCHAR2(2),
    NMFORMPGTO     VARCHAR2(30),
    IDCLIEATIV     VARCHAR2(1) NOT NULL,
    IDINTERFACE    VARCHAR2(1) NOT NULL,
    LOG_ERRO       VARCHAR2(250),
    DTGRAVACAO     DATE NOT NULL,
    HRGRAVACAO     VARCHAR2(5) NOT NULL,
    DTIMPORTACAO   DATE,
    HRIMPORTACAO   VARCHAR2(5)
  )
/

ALTER TABLE USR_CISPROT_CLIENTE ADD constraint PK_USR_CISPROT_CLIENTE primary key (CGCCLIE)
/
CREATE INDEX USR_CISPROT_CLIENTE_01 ON USR_CISPROT_CLIENTE(DTIMPORTACAO)
/

-- ============================================================
--   Table: USR_CISPROT_FORNECEDOR
-- ============================================================
CREATE TABLE USR_CISPROT_FORNECEDOR
  (
    CGCFORNE      VARCHAR2(14) NOT NULL,
    CDFORPROTHEUS VARCHAR2(8) NOT NULL,
    NMRAZAOSOC    VARCHAR2(60) NOT NULL,
    NMFANTFORNE   VARCHAR2(20) NOT NULL,
    DSENDERECO    VARCHAR2(67),
    CDPAIS        VARCHAR2(5) NOT NULL,
    NMPAIS        VARCHAR2(30) NOT NULL,
    SGESTADO      VARCHAR2(2) NOT NULL,
    CDMUNCIPIO    VARCHAR2(7) NOT NULL,
    NMMUNICIPIO   VARCHAR2(30) NOT NULL,
    CDCEP         VARCHAR2(8),
    NMBAIRRO      VARCHAR2(20),
    EMAIL         VARCHAR2(100),
    CDFORMPGTO    VARCHAR2(2),
    NMFORMPGTO    VARCHAR2(30),
    IDFORNATIV    VARCHAR2(1) NOT NULL,
    IDINTERFACE   VARCHAR2(1) NOT NULL,
    LOG_ERRO      VARCHAR2(250),
    DTGRAVACAO    DATE NOT NULL,
    HRGRAVACAO    VARCHAR2(5) NOT NULL,
    DTIMPORTACAO  DATE,
    HRIMPORTACAO  VARCHAR2(5)
  )
/

ALTER TABLE USR_CISPROT_FORNECEDOR ADD constraint PK_USR_CISPROT_FORNECEDOR primary key (CGCFORNE)
/
CREATE INDEX USR_CISPROT_FORNECEDOR_01 ON USR_CISPROT_FORNECEDOR(DTIMPORTACAO)
/

-- ============================================================
--   Table: USR_CISPROT_PRODUTO
-- ============================================================
CREATE TABLE USR_CISPROT_PRODUTO
  (
    CDPRODPROT   VARCHAR2(10) NOT NULL,
    PRODUTO      VARCHAR2(10),
    TIPO         VARCHAR2(1) NOT NULL,
    DESCTIPO     VARCHAR2(50) NOT NULL,
    GRUPO        VARCHAR2(2) NOT NULL,
    DESCGRUPO    VARCHAR2(50) NOT NULL,
    SUBGRUPO     VARCHAR2(2) NOT NULL,
    DESCSUBGRUPO VARCHAR2(50) NOT NULL,
    PASTA        VARCHAR2(3) NOT NULL,
    DESCPASTA    VARCHAR2(50) NOT NULL,
    NMPRODUTO    VARCHAR2(50) NOT NULL,
    SGUNIDADE    VARCHAR2(5) NOT NULL,
    VRFATCORR    FLOAT(10) NOT NULL,
    VRFATOCONV   FLOAT(10) NOT NULL,
    IDPRODESTO   VARCHAR2(1) NOT NULL,
    CDPRODESTO   VARCHAR2(10),
    IDPRODATIVO  VARCHAR2(1) NOT NULL,
    IDINTERFACE  VARCHAR2(1) NOT NULL,
    LOG_ERRO     VARCHAR2(250),
    DTGRAVACAO   DATE NOT NULL,
    HRGRAVACAO   VARCHAR2(5) NOT NULL,
    DTIMPORTACAO DATE,
    HRIMPORTACAO VARCHAR2(5)
  )
/

ALTER TABLE USR_CISPROT_PRODUTO ADD constraint PK_USR_CISPROT_PRODUTO primary key (CDPRODPROT)
/
CREATE INDEX USR_CISPROT_PRODUTO_01 ON USR_CISPROT_PRODUTO(DTIMPORTACAO)
/

-- ============================================================
--   Table: USR_CISORDEM_COMPRA
-- ============================================================
CREATE TABLE USR_CISORDEM_COMPRA
  (
    CDCENTCUST        VARCHAR2(12) NOT NULL,
    NRAUTOFORNE       VARCHAR2(10) NOT NULL,
    CDFORNECED        VARCHAR2(8)  NULL,
    NRNOTAFISCAL      VARCHAR2(9) NOT NULL,
    DTENTRADA         DATE NOT NULL,
    DTEMISSAO         DATE,
    CDPRODUTO         VARCHAR2(20) NOT NULL,
    VRQUANTIDADE      FLOAT(126) NOT NULL,
    VRQUANTAT         FLOAT(126) NOT NULL,
    VRUNITARIO        FLOAT(126) NOT NULL,
    CDSERIE           VARCHAR2(5),
    IDINTERFACE       VARCHAR2(1) NOT NULL,
    LOG_ERRO          VARCHAR2(250),
    DTGRAVACAO        DATE NOT NULL,
    HRGRAVACAO        VARCHAR2(5) NOT NULL,
    DTIMPORTACAO      DATE,
    HRIMPORTACAO      VARCHAR2(5),
    NRLANCESTQ       VARCHAR2(10)
  )
/
ALTER TABLE USR_CISORDEM_COMPRA MODIFY CDFORNECED NOT NULL
/
ALTER TABLE USR_CISORDEM_COMPRA ADD constraint PK_USR_CISORDEM_COMPRA primary key (CDCENTCUST, NRNOTAFISCAL, CDFORNECED, NRAUTOFORNE, CDPRODUTO)
/
CREATE INDEX USR_CISORDEM_COMPRA_01 ON USR_CISORDEM_COMPRA(DTIMPORTACAO)
/

DROP TRIGGER CALLEXPORTAAF
/
DROP PROCEDURE callWebservice
/
DROP TRIGGER CALLEXPORTANFS
/


-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','6.35.038'); END;
/

